include:
  - template: 'Workflows/MergeRequest-Pipelines.gitlab-ci.yml'
  - template: Container-Scanning.gitlab-ci.yml
  - template: Dependency-Scanning.gitlab-ci.yml
  - template: SAST.gitlab-ci.yml
  - template: Code-Quality.gitlab-ci.yml

stages:
  - build
  - test
  - deploy

variables:
  CI_APPLICATION_REPOSITORY: "$CI_REGISTRY_IMAGE/build"
  CI_APPLICATION_TAG: "build-$CI_COMMIT_SHA"

build:
  image: docker:latest
  stage: build
  services:
    - docker:dind
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  script:
    - docker build --tag $CI_APPLICATION_REPOSITORY:$CI_APPLICATION_TAG .
    - docker push $CI_APPLICATION_REPOSITORY:$CI_APPLICATION_TAG

deploy-dev:
  image: docker:latest
  stage: deploy
  services:
    - docker:dind
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  script:
    - docker pull $CI_APPLICATION_REPOSITORY:$CI_APPLICATION_TAG
    - docker tag $CI_APPLICATION_REPOSITORY:$CI_APPLICATION_TAG $CI_REGISTRY_IMAGE:dev
    - docker push $CI_REGISTRY_IMAGE:dev
  rules:
    - if: '$CI_COMMIT_BRANCH == "main"'
      when: on_success

deploy-tag:
  image: docker:latest
  stage: deploy
  services:
    - docker:dind
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  script:
    - docker pull $CI_APPLICATION_REPOSITORY:$CI_APPLICATION_TAG
    - docker tag $CI_APPLICATION_REPOSITORY:$CI_APPLICATION_TAG $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG
    - docker tag $CI_APPLICATION_REPOSITORY:$CI_APPLICATION_TAG $CI_REGISTRY_IMAGE:latest
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG
    - docker push $CI_REGISTRY_IMAGE:latest
  rules:
    - if: '$CI_COMMIT_TAG'
      when: on_success
